<?phP
/*
Plugin Name: TinyFeed
Plugin URI: http://jpiche.com/tinyfeed/
Version: 1.0
Author: Joseph Piché
Author URI: http://jpiche.com/


Copyright 2009 Joseph Piché (email : j@jpiche.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


class TinyFeed_Widget extends WP_Widget {

    static $script_loaded = false;

    function TinyFeed_Widget() {
        $widget_opts = array('description' => __('Loads Microblog entries via Ajax') );
	parent::WP_Widget('tinyfeed', __('TinyFeed'), $widget_opts);
    }

    function widget($args, $inst) {
        if (isset($inst['error']) && $inst['error'])
	    return;

        extract($args);

	if (empty($inst['user']))
            return;

    if (empty($inst['title'])) {
      if ($inst['service']=='identi.ca')
        $inst['title'] = 'Identi.ca Feed';
      elseif ($inst['service']=='twitter')
        $inst['title'] = 'Twitter Feed';
      else # this shouldn't happen
        $inst['title'] = 'Microblog Feed';
    }

        echo $before_widget;

        if (!self::$script_loaded) {
            echo '<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.3.2/jquery.min.js"></script>',
                 '<script type="text/javascript" src="'.path_join(WP_PLUGIN_URL, basename( dirname( __FILE__ ) ).'/tinyfeed.js').'"></script>';
            self::$script_loaded = true;
        }

        echo '<div id="tinyfeed-control-'.$this->number.'" class="tinyfeed-box">',
              $before_title . $inst['title'] . $after_title,
             '<div id="tinyfeed-inner-'.$this->number.'"></div>',
             '<div id="tinyfeed-credits-'.$this->number.'" class="tinyfeed-credits">I use <a href="http://jpiche.com/tinyfeed/">TinyFeed</a></div>',
             '<script type="text/javascript">',
             'tinyfeed_init("tinyfeed-inner-'.$this->number.'","'.$inst['service'].'","'.urlencode($inst['user']).'",'.$inst['count'].');',
             '</script></div>',
             $after_widget;
    }

    /** @see WP_Widget::update */
    function update($new_instance, $old_instance) {				
        return $new_instance;
    }

    function form($inst) {
?>
        <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?> <i>(optional)</i></label>
        <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($inst['title']); ?>" /></p>

        <p><label for="<?php echo $this->get_field_id('user'); ?>"><?php _e('Microblog Username or User ID:'); ?></label>
        <input class="widefat" id="<?php echo $this->get_field_id('user'); ?>" name="<?php echo $this->get_field_name('user'); ?>" type="text" value="<?php echo esc_attr($inst['user']); ?>" /></p>

        <p><label for="<?php echo $this->get_field_name('service'); ?>"><?php _e('Microblog service:'); ?></label><br/>
        <input name="<?php echo $this->get_field_name('service'); ?>" type="radio" value="identi.ca" <?php if($inst['service']=='identi.ca') echo 'checked="checked"';?>/> Identi.ca<br/>
        <input name="<?php echo $this->get_field_name('service'); ?>" type="radio" value="twitter" <?php if($inst['service']=='twitter') echo 'checked="checked"';?>/> Twitter</p>

        <p><label for="<?php echo $this->get_field_id('count'); ?>"><?php _e('Number of entries to show'); ?></label>
        <select id="<?php echo $this->get_field_id('count'); ?>" name="<?php echo $this->get_field_name('count'); ?>">
        <?php
          for($i = 1; $i <= 10; $i++) {
            echo '<option ';
	    echo ($inst['count']==$i) ? ' selected="selected"' : '';
	    echo '>'.$i.'</option>';
	  }
	?>
	</select></p>
<?php
    }
}

add_action('widgets_init', create_function('','return register_widget(\'TinyFeed_Widget\');'));
add_action('wp_head', 'TinyFeed_Widget_CSS_init');

function TinyFeed_Widget_css_init() {
  echo '<link type="text/css" rel="stylesheet" href="'.path_join(WP_PLUGIN_URL, basename( dirname( __FILE__ ) ).'/tinyfeed.css').'"/>';
}
